﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using PCLStorage;
using System.Diagnostics;

using Xamarin.Forms;

namespace Bring
{
	public partial class ParentPage : ContentPage
	{
		ObservableCollection<ItemClass> _bringData = new ObservableCollection<ItemClass>();

		public ParentPage()
		{
			InitializeComponent();

			SetListView();

			ToolbarItems.Add(new ToolbarItem
			{
				Text = "コピー",
				Command = new Command(() =>
				{
					App._clipboard.CopyToClipboard(App._bringUInt.ToString());
				})
			});
		}

		public void SetListView()
		{
			_bringData.Clear();
			for (var i = 0; i < 32; i++)
			{
				Debug.WriteLine("{0}", App._bring32[i]);
				_bringData.Add(new ItemClass { Id = i.ToString(), Text = App._bringItem[i], Checked = App._bring32[i] });
			}
			_bringListView.ItemsSource = _bringData;

			Title = App._bringUInt.ToString();
		}

		protected void OnChanged(object sender, EventArgs e)
		{
			var item = sender as SwitchCell;
			var id = int.Parse(item.ClassId);
			if (App._bring32[id] != item.On)
			{
				App._bring32[id] = item.On;
				var four = new UInt32[] { 1, 2, 4, 8 };
				App._bringUInt = 0;
				for (var i = 0; i < 32; i++)
				{
					if (App._bring32[i])
					{
						var shift = (int)(i / 4) * 4;
						App._bringUInt |= (four[i % 4] << shift);
					}
				}
				Title = App._bringUInt.ToString();
			}
		}
	}
}