﻿using System.Threading.Tasks;
using Android.App;
using Android.Widget;
using Xamarin.Forms;

using Bring;
using Bring.Droid;

[assembly: Dependency(typeof(EntryAlert))]

namespace Bring.Droid
{
	public class EntryAlert : IEntryAlert
	{
		public Task<EntryAlertResult> Show(string title, string text, string ok, string cancel)
		{
			var tcs = new TaskCompletionSource<EntryAlertResult>();

			var editText = new EditText(Forms.Context);
			editText.Text = text;

			new AlertDialog.Builder(Forms.Context)
				.SetTitle(title)
				.SetView(editText)
				.SetNegativeButton(cancel, (o, e) => tcs.SetResult(new EntryAlertResult
				{
					IsOK = false,
					Text = editText.Text
				}))
				.SetPositiveButton(ok, (o, e) => tcs.SetResult(new EntryAlertResult
				{
					IsOK = true,
					Text = editText.Text
				}))
				.Show();

			return tcs.Task;
		}
	}
}