﻿using Bring;
using Bring.iOS;
using Xamarin.Forms;
using UIKit;
using System.Threading.Tasks;

[assembly: Dependency(typeof(EntryAlert))]

namespace Bring.iOS
{
	public class EntryAlert : IEntryAlert
	{
		public Task<EntryAlertResult> Show(string title, string text, string ok, string cancel)
		{
			var tcs = new TaskCompletionSource<EntryAlertResult>();

			UIApplication.SharedApplication.InvokeOnMainThread(() =>
			{
				var alert = new UIAlertView(title, null, null, cancel, new[] { ok });

				alert.AlertViewStyle = UIAlertViewStyle.PlainTextInput;
				alert.GetTextField(0).Text = text;

				alert.Clicked += (sender, e) => tcs.SetResult(new EntryAlertResult
				{
					IsOK = (alert.ButtonTitle(e.ButtonIndex) == ok) ? true:false,
					Text = alert.GetTextField(0).Text
				});
				alert.Show();
			});

			return tcs.Task;
		}
	}
}
